'Here are some useful articles when creating new PC applications for COM ports:
'(links valid as of June 3, 2008)
'
'"SerialPort Class"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.aspx
'
'"SerialPort Members"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport_members.aspx
'
'"SerialPort.DataReceived Event"
'http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.datareceived.aspx
'
'"How to: Make Thread-Safe Calls to Windows Forms Controls"
'http://msdn.microsoft.com/en-us/library/ms171728(VS.80).aspx
'
'"Visual Basic Developer Center"
'http://msdn.microsoft.com/en-us/vbasic/default.aspx?pull=/library/en-us/vbcon/html/vboriintroductiontovisualbasic70forvisualbasicveterans.asp

Imports System.IO.Ports

Public Class Form1

    'txtDataReceivedeLXg{bNXɕރXbĥ߂̃fQ[g֐쐬܂
    Delegate Sub SetTextCallback(ByVal [text] As String)

    'Form1NX̃RXgN^B̊֐쐬tH[IuWFNĝׂĂ܂B
    Private Sub UpdateCOMPortList()
        Dim s As String
        Dim i As Integer
        Dim foundDifference As Boolean

        i = 0
        foundDifference = False
        'If the number of COM ports is different than the last time we
        '  checked, then we know that the COM ports have changed and we
        '  don't need to verify each entry.

        If lstCOMPorts.Items.Count = SerialPort.GetPortNames().Length Then
            'Search the entire SerialPort object.  Look at COM port name
            '  returned and see if it already exists in the list.
            For Each s In SerialPort.GetPortNames()
                'If any of the names have changed then we need to update 
                '  the list
                If lstCOMPorts.Items(i).Equals(s) = False Then
                    foundDifference = True
                End If
                i = i + 1
            Next s
        Else
            foundDifference = True
        End If

        'If nothing has changed, exit the function.
        If foundDifference = False Then
            Exit Sub
        End If

        'If something has changed, then clear the list
        lstCOMPorts.Items.Clear()

        'Add all of the current COM ports to the list
        For Each s In SerialPort.GetPortNames()
            lstCOMPorts.Items.Add(s)
        Next s
        'Set the listbox to point to the first entry in the list
        lstCOMPorts.SelectedIndex = 0
    End Sub


    'Timer1Intervalɐݒ肵lmsɎs܂B
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        'Update the COM ports list so that we can detect
        '  new COM ports that have been added.
        UpdateCOMPortList()
    End Sub


    'Connect{^Ǝs܂B
    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            'Get the port name from the application list box.
            '  the PortName attribute is a string name of the COM
            '  port (e.g. - "COM1").
            SerialPort1.PortName = lstCOMPorts.Items(lstCOMPorts.SelectedIndex).ToString()

            'Open the COM port.
            SerialPort1.Open()

            'Change the state of the application objects
            btnConnect.Enabled = False
            lstCOMPorts.Enabled = False
            btnClose.Enabled = True

            'Clear the textbox and print that we are connected.
            txtDataReceived.Clear()
            txtDataReceived.AppendText("Connected." + vbCrLf)
        Catch ex As Exception
            'If there was an exception, then close the handle to 
            '  the device and assume that the device was removed
            btnClose_Click(Me, e)

        End Try
    End Sub


    'Close{^Ǝs܂B
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        'Reset the state of the application objects
        btnClose.Enabled = False
        btnConnect.Enabled = True
        lstCOMPorts.Enabled = True

        Try

            'Dispose the In and Out buffers;
            SerialPort1.DiscardInBuffer()
            SerialPort1.DiscardOutBuffer()
            'Close the COM port
            SerialPort1.Close()
            'If there was an exeception then there isn't much we can
            '  do.  The port is no longer available.
        Catch ex As Exception

        End Try
    End Sub


    'f[^COM|[gŎMƁÅ֐ĂяotxtDataReceivedeLXg{bNXɂ̃f[^݂܂
    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        'ReadExistingij֐́ACOM|[g̃obt@Ɍݗp\ȂׂẴf[^ǂݍ݂܂B
        '̗ł́AsetTextij֐Ɏgp\COM|[ĝׂẴf[^𑗐MĂ܂B
        'F<SerialPort>_DataReceivedij֐́AAvP[V̑̕ƗXbhŋN܂B
        'fQ[g@\,ÃXbh̓̊ǗΏۃIuWFNgɃANZX邽߂ɕKvłB
        'ǗΏۃIuWFNgtextBoxɏƂɂȂ܂̂ŁAfQ[g@\v܂B
        'fQ[g̋@\Ƃ̎gp@̏ڍׂɂẮAsetTextij֐QƂĂB
        Try
            SetText(SerialPort1.ReadExisting())
        Catch ex As Exception
            'If there was an exception, then close the handle to the device and assume that the device was removed
            btnClose_Click(Me, e)
        End Try

    End Sub


    '̊֐́AtxtDataReceivedeLXg{bNXɓ͂ꂽeLXgo͂܂B
    'ĂяõXbheLXg{bNXLXbhƓłꍇAappendTextij\bh𒼐ڌĂяo܂B
    'CXbhȊO̊֐Ăяoꍇ́ACXbhōĂюs悤ɁAfQ[g֐̃CX^X쐬܂B
    Private Sub SetText(ByVal [text] As String)
        'InvokeRequired͌ĂяõXbhIDƍ쐬XbhID̔r̂ߕKvłB
        '̃XbhقȂĂꍇ́AtrueԂ܂B
        'eLXg{bNXɃeLXg𒼐ڒǉł邩AfQ[g֐̃CX^XNKv邩̑𗘗p܂B
        If txtDataReceived.InvokeRequired Then
            'deleage@\NKv܂B
            'SetTextCallbackfQ[g̃CX^X쐬AfQ[g̋@\蓖Ă܂B
            '͎ÃXbh̑ɁAsetTextij֐ACXbhŌĂяo܂B
            Dim d As New SetTextCallback(AddressOf SetText)

            '̃Xbh炱̊֐ɓnꂽeLXg𑗐MVfQ[gĂяo܂
            Invoke(d, New Object() {[text]})
        Else
            'If this function was called from the same thread that 
            '  holds the required objects then just add the text.
            txtDataReceived.AppendText(text)
        End If
    End Sub


    'SendData{^ꂽƂɎs܂B
    Private Sub btnSendData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendData.Click
        Try
            'Write the data in the text box to the open serial port
            SerialPort1.Write(txtData.Text)
        Catch ex As Exception
            'If there was an exception, then close the handle to 
            '  the device and assume that the device was removed
            btnClose_Click(Me, e)
        End Try
    End Sub
End Class
